/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.entschaedigung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.entschaedigung.boundary.AbstractEntschaedigungSearchParameters;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungChangeEvent;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungConversationStore;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungExtendedDAO;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungSearch;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;
import de.ivu.elect.business.entschaedigung.entity.EntschaedigungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractEntschaedigungSearchView.COMPONENT_NAME)
@View(viewId = AbstractEntschaedigungSearchView.VIEW_ID, useCase = UseCasePermission.ENTSCHAEDIGUNG_SEARCH)
public abstract class AbstractEntschaedigungSearchView extends AbstractElectSearchView<Entschaedigung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungSearchView";
  
  public static final String VIEW_ID = "/entschaedigung/entschaedigung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractEntschaedigungSearchView requestHandler;

  @Inject
  private transient EntschaedigungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(EntschaedigungConversationStore.class)
  protected transient EntschaedigungConversationStore conversationStore;

  @Inject
  protected transient EntschaedigungSearch search;

  @Inject
  @ConversationGroup(AbstractEntschaedigungSearchParameters.class)
  protected transient EntschaedigungSearchParameters searchParameters;

  @Inject
  protected transient EntschaedigungMeta entityMeta;

  public AbstractEntschaedigungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Entschaedigung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Entschaedigung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public EntschaedigungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Entschaedigung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Entschaedigung> create();
  }

  @Override
  public List<Entschaedigung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Entschaedigung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onEntschaedigungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) EntschaedigungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractEntschaedigungSearchView {

    @View
    @Inject
    private transient Instance<AbstractEntschaedigungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractEntschaedigungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
